Attach Files to a Task tasks.task.file.attach

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: tasks

Who can execute the method: task Creator or a user with edit access to the task

The method tasks.task.file.attach adds files from Drive to a task. The user must have read access to the file or higher.

Method Parameters

Required parameters are marked with *

Name
type

Description

taskId*
integer

The identifier of the task to which files need to be attached.

The task identifier can be obtained when creating a new task or by using the old method of getting the task list

fileIds*
array<integer>

An array of file identifiers from Drive.

File identifiers can be obtained in two ways.

Use one of the file upload methods:

Use one of the methods to get the list of files:

Code Examples

How to Use Examples in Documentation

The new API call differs by the addition of the /api/ parameter in the request:

https://{installation_address}/rest/api/{user_id}/{webhook_token}/tasks.task.file.attach

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"taskId":8017,"fileIds":[1065,1077]}' \
        https://**put_your_bitrix24_address**/rest/api/**put_your_user_id_here**/**put_your_webhook_here**/tasks.task.file.attach
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"taskId":8017,"fileIds":[1065,1077],"auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/api/tasks.task.file.attach
        

The SDK does not currently support calls to the address /rest/api/. Use direct HTTP requests, for example, via curl or fetch.

try
        {
            const response = await $b24.callMethod(
                'tasks.task.file.attach',
                {
                    taskId: 8017,
                    fileIds: [1065, 1077],
                }
            );
            
            const result = response.getData().result;
            console.log('Files attached:', result);
            
            processResult(result);
        }
        catch( error )
        {
            console.error('Error:', error);
        }
        

The SDK does not currently support calls to the address /rest/api/. Use direct HTTP requests, for example, via curl or fetch.

try {
            $response = $b24Service
                ->core
                ->call(
                    'tasks.task.file.attach',
                    [
                        'taskId' => 8017,
                        'fileIds' => [1065, 1077]
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
            processData($result);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error attaching file: ' . $e->getMessage();
        }
        

The SDK does not currently support calls to the address /rest/api/. Use direct HTTP requests, for example, via curl or fetch.

BX24.callMethod(
            'tasks.task.file.attach',
            {
                taskId: 8017,
                fileIds: [1065, 1077]
            },
            function(result){
                console.info(result.data());
                console.log(result);
            }
        );
        

The SDK does not currently support calls to the address /rest/api/. Use direct HTTP requests, for example, via curl or fetch.

require_once('crest.php');
        
        $result = CRest::call(
            'tasks.task.file.attach',
            [
                'taskId' => 8017,
                'fileIds' => [1065, 1077]
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP Status: 200

{
            "result": {
                "result": true
            },
            "time": {
                "start": 1765357239,
                "finish": 1765357239.724951,
                "duration": 0.7249510288238525,
                "processing": 0,
                "date_start": "2025-12-10T12:00:39+01:00",
                "date_finish": "2025-12-10T12:00:39+01:00",
                "operating_reset_at": 1765357839,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
boolean

The root element of the response.

Contains an object with the key result and the value true if the file was successfully attached

time
time

Information about the request execution time

Error Handling

HTTP Status: 400

{
            "error": {
                "code": "BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION",
                "message": "Error validating the request object",
                "validation": [
                    {
                        "message": "The required field `taskId` is missing",
                        "field": "taskId"
                    }
                ]
            }
        }
        

Name
type

Description

error.code
string

String error code. Use it to identify the type of exception

error.message
string

Text description of the error

error.validation
array

Array with error details. Present only in data validation errors BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

error.validation[].field
string

Name of the field where the validation error occurred

error.validation[].message
string

Description of the error related to the specified field

Possible Error Codes

Request Validation Errors

Error Code: BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

Field

Error Description

How to Fix

taskId
fileIds

The required field #FIELD# is missing

Add the specified field to the request body

#FIELD#

The field #FIELD# requires data type #TYPE# for this request

Ensure the provided value is of the correct type

Insufficient permissions

No access to the specified file or task

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning